import java.io.*;    // Use java.io package
import java.util.*;
import java.lang.*;

class CFile
{
String DiscName;
String FileName;
int TotalChars=0;
int TotalTracks=0;
Vector VTracks;
static int MAXChars=1700;

public int GetTotalTracks(){
        return (TotalTracks);
}
public String GetDiscName(){
	return (DiscName);
}

public int GetTotalChars(){
	return (TotalChars);
}
public void SetDiscName(String Param){
        StringTokenizer st = new java.util.StringTokenizer( Param, "." );
        FileName=Param;
        DiscName=st.nextToken();

}

public String DisplayTrack(int i){
        CTracks Track = new CTracks();

        if (VTracks.isEmpty()){
               System.out.println("vacio");
               System.exit(1);
               }
        Track = (CTracks) VTracks.elementAt(i);

        return ((VTracks.indexOf(Track)+1)+". "+Track.GetArtist()+"-"+Track.GetSong());
}

public String DiscInfo(){
        return ("Disc Name: "+DiscName+"\n"+"Total Chars: "+TotalChars+" of "+MAXChars+"   "+"Total tracks: "+TotalTracks);
}

public boolean EditTrack(int index, String newArtist, String newSong){
	CTracks newTrack = new CTracks();
        CTracks oldTrack = new CTracks();
        newTrack.SetTrack(newArtist,newSong);
        newTrack.SetPos(index+1);  //ojo con lo que se recibe, index parte de cero en list
        oldTrack = (CTracks) VTracks.set(index,newTrack);

        if ((oldTrack.GetArtist() == newTrack.GetArtist()) || (oldTrack.GetSong() == newTrack.GetSong()))
                return false;
        else
                return true;
}

public void UpDatePos(Vector VTracks){
        CTracks Track = new CTracks();
        for (int i=0;i<VTracks.size();i++){
                Track =(CTracks) VTracks.elementAt(i);
                Track.SetPos(VTracks.indexOf(Track));
        }

}

public void RemoveTrack(int index){
	CTracks newTrack = new CTracks();
	VTracks.removeElementAt(index);
        TotalTracks = VTracks.size();
        UpDatePos(VTracks);
}

public void AddTrackAt(int index, CTracks Track){
	VTracks.add(index,Track);
	TotalTracks = VTracks.size();
}

public Vector DisplayAll(){
	Vector Ret;
	CTracks Track = new CTracks();
        Ret = new Vector();
        for (int i=0;i<VTracks.size();i++){
		Track = (CTracks) VTracks.elementAt(i);
		Ret.addElement(DisplayTrack(i));

	}
	return Ret;
}

public void WriteTracks(){


        File outFile = new File(DiscName + ".out");
	CTracks Track = new CTracks();

        try{
        BufferedWriter outFileLine = new BufferedWriter(new FileWriter(outFile));

	for (int i=0;i<VTracks.size();i++){
		Track = (CTracks) VTracks.elementAt(i);
		outFileLine.write(Track.GetArtist()+";"+Track.GetSong());
        	outFileLine.newLine();

	}

	outFileLine.close();
        }
        catch(IOException e){
        System.out.println("Error al escribir");
        }

        //return true;
}

public void ReadTracks(){
     File inFile=new File(FileName);

     try{
        if ( inFile.exists() )
        {
            // Create the buffered reader for reading the file
        BufferedReader inFileLine = new BufferedReader(new FileReader( inFile ));
        VTracks= new Vector();
        String line = inFileLine.readLine();
        //CTracks Temp = new CTracks();
        int index=1;

        while ( line != null ){
                CTracks Track = new CTracks();
                StringTokenizer st = new java.util.StringTokenizer( line, ";" );        //get chars until blankspace
                Track.SetTrack(st.nextToken(),st.nextToken());
                Track.SetPos(index);
                TotalChars = TotalChars+Track.GetNumOfChars();
                VTracks.addElement(Track);
                line = inFileLine.readLine();
		index=index+1;

	}
        TotalTracks = VTracks.size();
        // Close the BufferedReader
        inFileLine.close();

        }

    }
    catch(IOException e){
      System.err.println("Error haciendo algo...");
      System.exit(1);
   }
 }

}
